with Philosophers;

procedure Main is
   use Philosophers;

   --  the set of congregated dining philosophers
   Dining_Philosophers : array (Position_T) of Philosopher_Ref;
   --  the respective voluntary suspension intervals (in milliseconds)
   Wait_Times          :
     array (Position_T) of Positive := (500, 750, 1_000, 1_250, 1_500);

   --  and the respective reflection intervals (in milliseconds)
   Think_Loads         :
     array (Position_T) of Positive := (300, 250, 200, 150, 100);

begin
   --  we first create all instances of all philosophers
   for P in Position_T loop
      Dining_Philosophers (P) := new Philosopher_T
        (My_Position => P,
         Think_Load => Think_Loads (P),
         Some_Time => Wait_Times (P));
   end loop;
   --  and then let them do their job without interfering
   loop
      null;
   end loop;
end Main;
